<app-loading *ngIf="isLoading"></app-loading>
<div class="content">
  <mb-button *ngIf='objFunction?.create' mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="showModalAssessment(footerTmpl, 'ADD')"
  mbButtonText="{{'common.button.add' | translate}}" mbButtonAvailableStyle="PRIMARY"></mb-button>
</div>

<ng-template #footerTmpl>
  <mb-button mbButtonAvailableStyle="PRIMARY" mbButtonText="{{'common.button.saveS' | translate}}"
  (click)="modalRef.getContentComponent().save()">
 </mb-button>
  <mb-button mbButtonAvailableStyle="BtnCancelHasBorder" mbButtonText="{{'common.button.cancel' | translate}}" (click)="modalRef.destroy()">
  </mb-button>
</ng-template>
<div class="form-setup-assessment">
  <form nz-form [formGroup]="form">
    <div nz-row [nzGutter]="[30, 10]">
      <div nz-col nzSm="24" nzXs="24" nzLg="6">
        <mb-input-text formControlName="name"
          [mbType]="isSubmitted && form.controls['name'].errors ? 'error' : 'default'" [mbMaxLength]="50"
          [mbShowError]="isSubmitted && form.controls['name'].errors !== null" [mbErrors]="form.controls['name'].errors"
          [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'goaManagement.validate.maxLength' | translate: {'numberLength': '50' }},
         { errorName: 'name', errorDescription: 'goaManagement.validate.name' | translate }]"
          mbPlaceholderText="{{'targerManager.common.input.placeholderSearch' | translate}}"
          mbLabelText="{{'targerManager.setupAssessment.assessmentName' | translate}}"
          (mbKeyup)="enterSearch($event)">
        </mb-input-text>
      </div>
      <div nz-col nzSm="24" nzXs="24" nzLg="6">
        <mb-input-text formControlName="code"
          [mbType]="isSubmitted && form.controls['code'].errors ? 'error' : 'default'" [mbMaxLength]="50"
          [mbShowError]="isSubmitted && form.controls['code'].errors !== null" [mbErrors]="form.controls['code'].errors"
          [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'goaManagement.validate.maxLength' | translate: {'numberLength': '50' }},
         { errorName: 'code', errorDescription: 'goaManagement.validate.code' | translate }]"
          mbPlaceholderText="{{'targerManager.common.input.placeholderSearch' | translate}}"
          mbLabelText="{{'targerManager.setupAssessment.assessmentCode' | translate}}"
          (mbKeyup)="enterSearch($event)">
        </mb-input-text>
      </div>
      <div nz-col nzSm="24" nzXs="24" nzLg="6">
        <mb-select formControlName="cycleType" [mbDataSelects]="mbDataSelectsAssessmentCycle" [mbShowSearch]="false"
          mbLabelText="{{'targerManager.setupAssessment.assessmentCycle' | translate}}" mbKeyLabel="lvaMean"
          mbKeyValue="lvaValue">
        </mb-select>
      </div>
      <div nz-col nzSm="24" nzXs="24" nzLg="6">
        <mb-select formControlName="flagStatus" [mbDataSelects]="mbDataSelectsAssessmentStatus" [mbShowSearch]="false"
          mbLabelText="{{'targerManager.setupAssessment.flagStatus' | translate}}">
        </mb-select>
      </div>
    </div>
  </form>
  <div class="search_assessement">
    <mb-button mbButtonAvailableStyle="CUSTOM" (click)="search()"
      mbButtonText="{{'common.label.search' | translate}}"></mb-button>
  </div>
</div>


  <nz-table #basicTable [nzData]="listDataAssessment" class="data-table ant-table-content" [nzScroll]="listDataAssessment?.length > 2 ? { 'x': '400px', y: '450px' } : {}"
    [nzShowPagination]="false" nzTableLayout="fixed" nzSize='small' [nzPageSize]='limit'>
    <thead>
      <tr>
        <th [nzAlign]='nzAlignTh' id='index' nzLeft class="text-nowrap" nzWidth="4rem">{{'targerManager.table.stt' | translate}}</th>
        <th [nzAlign]='nzAlignTh' id='AssessmentCode' class="text-nowrap">{{'targerManager.setupAssessment.label.table.AssessmentCode' | translate}}</th>
        <th [nzAlign]='nzAlignTh' id='AssessmentName' class="text-nowrap">{{'targerManager.setupAssessment.label.table.AssessmentName' | translate}}</th>
        <th [nzAlign]='nzAlignTh' id='assessmentCycle' class="text-nowrap">{{'targerManager.setupAssessment.assessmentCycle' | translate}}</th>
        <th [nzAlign]='nzAlignTh' id='initialDate' class="text-nowrap">{{'targerManager.setupAssessment.label.table.initialDate' | translate}}</th>
        <th [nzAlign]='nzAlignTh' id='fromDate' class="text-nowrap">{{'targerManager.setupAssessment.label.table.fromDate' | translate}}</th>
        <th [nzAlign]='nzAlignTh' id='toDate' class="text-nowrap">{{'targerManager.setupAssessment.label.table.toDate' | translate}}</th>
        <th [nzAlign]='nzAlignTh' id='editableDate' class="text-nowrap">{{'targerManager.setupAssessment.label.table.editableDate' | translate}}</th>
        <th [nzAlign]='nzAlignTh' id='finishDate' class="text-nowrap">{{'targerManager.setupAssessment.label.table.finishDate' | translate}}</th>
        <th [nzAlign]='nzAlignTh' id='isLoopAble' class="text-nowrap">{{'targerManager.setupAssessment.label.table.isLoopAble' | translate}}</th>
        <th [nzAlign]='nzAlignTh' id='flagStatus' class="text-nowrap">{{'targerManager.setupAssessment.label.table.flagStatus' | translate}}</th>
        <th nzWidth="6em" nzAlign='center' id='action' *ngIf='objFunction?.delete' nzRight class="text-nowrap"></th>
      </tr>
    </thead>
    <tbody>
      <tr class="tr-for-class" *ngFor="let data of basicTable.data ;let i = index;trackBy: trackFnTable"
          (dblclick)="showModalAssessment(footerTmpl, 'EDIT', data)">
        <td nzLeft nzWidth="3rem">{{validateService.getRowIndex(i, pageable?.currentPage, basicTable.nzPageSize)}}</td>
        <td>{{ data?.pcfCode }}</td>
        <td>{{ data?.pcfName }}</td>
        <td>{{ data?.cycleType }}</td>
        <td>{{ data?.initialNum }}</td>
        <td>{{ data?.fromDate | date: 'dd/MM/yyyy'}}</td>
        <td>{{ data?.toDate | date: 'dd/MM/yyyy'}}</td>
        <td>{{ data?.editableNum }}</td>
        <td>{{ data?.finishNum }}</td>
        <td>
          <label nz-checkbox nzDisabled [ngModel]="ConvertString(data?.isLoopAble) ? true : false"></label>
        </td>
        <td>
          <nz-tag [nzColor]="'blue'" *ngIf="data.flagStatus === 1; else tplFlagStatus">{{'targerManager.common.label.flagStatusActive' | translate}}</nz-tag>
          <ng-template #tplFlagStatus>
            <nz-tag [nzColor]="'red'">{{'targerManager.common.label.flagStatusNotActive' | translate}}</nz-tag>
          </ng-template>
        </td>
         <td nzWidth="3rem" nzRight *ngIf='objFunction?.delete' nzAlign='center'>
           <mb-button-icon mbButtonType='DELETE' (click)="showConfirm(data?.pcfId, $event)"></mb-button-icon>
        </td>
      </tr>
    </tbody>
  </nz-table>
  <div class="pagination" *ngIf="listDataAssessment && listDataAssessment?.length > 0" >
    <div class="pagination__table-info">
      <img class="pagination__table-info--icon" src="assets/images/icon/idea.svg" alt='idea'/>
      <span class="pagination__table-info--text">Tìm thấy {{ pageable?.totalElements }} kết quả, hiển thị từ
        {{ pageable?.size * (pageable?.currentPage - 1) + 1 }} đến
        {{ pageable?.size * (pageable?.currentPage - 1) + pageable?.numberOfElements }}</span>
    </div>
    <nz-pagination [(nzPageIndex)]="pageable && pageable.currentPage" [nzTotal]="pageable?.totalElements"
      [nzPageSize]="pageable?.size" (nzPageIndexChange)="search($event)" class="pagination__icon">
    </nz-pagination>
  </div>

